Pull out rocky patches
[fuel.git] / mcp / config / states / maas
index 0c01617..47f66a4 100755 (executable)
@@ -1,69 +1,55 @@
-#!/bin/bash
-function wait_for() {
-  local cmdstr=$@
-  local total_attempts=360
-  local sleep_time=10
-  local attempt=1
-  echo "[NOTE] Waiting for cmd to return success: ${cmdstr}"
-  while ((attempt <= total_attempts)); do
-    eval "${cmdstr}" && break || true
-    echo -n '.'; sleep "${sleep_time}"
-    ((attempt+=1))
+#!/bin/bash -e
+# shellcheck disable=SC1090
+##############################################################################
+# Copyright (c) 2018 Mirantis Inc., Enea AB and others.
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
+
+CI_DEBUG=${CI_DEBUG:-0}; [[ "${CI_DEBUG}" =~ (false|0) ]] || set -x
+ERASE_ENV=${ERASE_ENV:-0}
+
+source "$(dirname "${BASH_SOURCE[0]}")/../../scripts/globals.sh"
+source "$(dirname "${BASH_SOURCE[0]}")/../../scripts/lib.sh"
+
+bm_nodes=$(salt --out yaml 'mas01*' pillar.get maas:region:machines | \
+           awk '/^\s+\w+[[:digit:]]+:$/ {gsub(/:$/, "*"); printf "%s ", $1}')
+
+# Optionally destroy MaaS machines from a previous run
+if [ "${ERASE_ENV}" -gt 1 ]; then
+  cleanup_uefi
+  for node_hostname in ${bm_nodes//\*/}; do
+    salt -C 'mas01*' maasng.delete_machine "${node_hostname}" || true
   done
-}
+fi
 
 # MaaS rack/region controller, node commissioning
-salt -C 'mas01*' cmd.run "add-apt-repository ppa:maas/stable"
-
-salt -C 'mas01*' state.apply linux,salt,openssh,ntp
-salt -C 'mas01*' state.apply linux.network.interface
-salt -C 'mas01*' state.apply maas.pxe_nat
+wait_for 10.0 "salt -C 'mas01*' state.apply linux,salt,openssh,ntp,iptables"
 salt -C 'mas01*' state.apply maas.cluster
-salt -C 'cfg01*' cmd.run \
-  "route add -net 192.168.11.0/24 gw ${MAAS_IP:-192.168.10.3}"
-
-wait_for "salt -C 'mas01*' state.apply maas.region"
-
-salt -C 'mas01*' state.apply maas.machines
-# TODO: relax cond, as this is not re-entrant (e.g. nodes already deployed)
-wait_for "salt 'mas01*' --out yaml state.apply maas.machines.status | " \
-         "tee /dev/stderr | fgrep -q 'Ready: 5'"
-
-# MaaS node deployment
-salt -C 'mas01*' state.apply maas.machines.deploy
-wait_for "salt 'mas01*' --out yaml state.apply maas.machines.status | " \
-         "tee /dev/stderr | fgrep -q 'Deployed: 5'"
-
-salt -C 'mas01*' pillar.item\
-  maas:region:admin:username \
-  maas:region:admin:password
 
-# KVM, compute node prereqs (libvirt first), VCP deployment
-salt -C '* and not cfg01* and not mas01*' saltutil.sync_all
+wait_for 10 "salt -C 'mas01*' state.apply maas.region"
 
-salt -C 'kvm*' pkg.install bridge-utils
-salt -C 'kvm*' state.apply linux.network
-salt -C 'kvm*' system.reboot
-wait_for "! salt '*' test.ping | tee /dev/stderr | fgrep -q 'Not connected'"
+if [ -n "${bm_nodes}" ]; then
+  salt -C 'mas01*' state.apply maas.machines
+fi
 
-salt -C '* and not cfg01* and not mas01*' state.apply linux,ntp
+# cleanup outdated salt keys
+sleep 30
+salt-key --out yaml | awk '!/^(minions|- cfg01|- mas01)/ {print $2}' | \
+  xargs --no-run-if-empty -I{} salt-key -yd {}
 
-salt -C 'kvm*' state.sls libvirt
-
-salt -C '* and not cfg01* and not mas01*' state.apply salt
-salt -C 'kvm*' state.sls salt.control
-
-vcp_nodes=$(salt --out yaml 'kvm01*' pillar.get salt:control:cluster:internal:node | awk '/\s+\w+:$/ {gsub(/:$/, "*"); print $1}')
-
-# Check all vcp nodes are available
-rc=1
-while [ $rc -ne 0 ]; do
-  rc=0
-  for node in $vcp_nodes; do
-    salt "$node" test.ping 2>/dev/null 1>&2 || { rc=$?; break; };
-  done
-done
-
-salt -C '* and not cfg01* and not mas01*' saltutil.sync_all
-salt -C '* and not cfg01* and not mas01*' state.apply salt
-salt -C '* and not cfg01* and not mas01*' state.apply linux,ntp
+# MaaS node deployment
+if [ -n "${bm_nodes}" ]; then
+  notify "[NOTE] MaaS operations might take a long time, please be patient" 2
+  salt -C 'mas01*' state.apply maas.machines.wait_for_ready_or_deployed
+  salt -C 'mas01*' state.apply maas.machines.storage
+  salt -C 'mas01*' state.apply maas.machines.deploy
+  salt -C 'mas01*' state.apply maas.machines.wait_for_deployed
+fi
+
+# Check all baremetal nodes are available
+wait_for 10.0 "(for n in ${bm_nodes}; do salt \${n} test.ping 2>/dev/null || exit; done)"
+
+wait_for 10.0 "salt -C '* and not cfg01* and not mas01*' saltutil.sync_all"